package com.its.op.service.its.ifsc;

import com.its.op.dao.repository.its.ifsc.TbIfscVrtxArrRepository;
import com.its.op.dto.its.ifsc.TbIfscVrtxArrDto;
import com.its.op.entity.its.ifsc.TbIfscVrtxArr;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.ArrayList;
import java.util.List;

@Slf4j
@RequiredArgsConstructor
@Service
public class TbIfscVrtxArrService {

    private final TbIfscVrtxArrRepository repo;

    // 전체 데이터 조회
    @Transactional(readOnly = true)
    public List<TbIfscVrtxArrDto> findAll() {
        List<TbIfscVrtxArrDto> result = new ArrayList<>();
        List<TbIfscVrtxArr> data = this.repo.findAll();
        for (TbIfscVrtxArr entity : data) {
            result.add(entity.toDto());
        }
        return result;
    }

    /**
     * 레벨에 따른 버텍스 정보 조회
     * @param levl
     * @return
     */
    public List<TbIfscVrtxArrDto> findAllByLevl(Integer levl) {
        List<TbIfscVrtxArrDto> result = new ArrayList<>();
        List<TbIfscVrtxArr> data = this.repo.findAllByLevl(levl);
        data.forEach(obj -> {
            result.add(obj.toDto());
        });
        return result;
    }
}
